<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="favicon.png">
  <title>Home | ToolDef documentation</title>
  <link rel="stylesheet" href="assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <h1>ToolDef documentation</h1>
   <div class="details">
    <span id="author" class="author">Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span>
    <br><span id="revnumber">version v6.0-RC1</span>
   </div>
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href=".">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-cur-page toc-item expanded">
      <div class="toc-item-marker"></div><a href="#">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="introduction.html">Introduction</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="language-reference/syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="language-reference/builtins/file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="language-reference/builtins/file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-6-0">Version 6.0</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="preamble">
    <div class="sectionbody">
     <div class="paragraph">
      <p>ToolDef is a cross-platform and machine-independent scripting language. It supports command line execution, but is also available as plug-in for the <a href="https://eclipse.org">Eclipse</a> IDE, providing an integrated development experience.</p>
     </div>
     <div class="paragraph">
      <p>ToolDef is one of the tools of the Eclipse ESCET™ project. Visit the <a href="https://eclipse.dev/escet/v6.0-RC1">project website</a> for downloads, installation instructions, source code, general tool usage information, information on how to contribute, and more.</p>
     </div>
     <div class="admonitionblock tip">
      <table>
       <tbody>
        <tr>
         <td class="icon"><i class="fa icon-tip" title="Tip"></i></td>
         <td class="content">You can <a href="eclipse-escet-tooldef-manual.pdf">download this manual</a> as a PDF as well. Or use the <a href="documentation-single-page.html">single-page HTML</a> version.</td>
        </tr>
       </tbody>
      </table>
     </div>
     <div class="paragraph">
      <p>The documentation consists of:</p>
     </div>
     <div class="ulist">
      <ul>
       <li>
        <p><a href="language-reference/index.html">ToolDef language reference manual</a></p></li>
       <li>
        <p><a href="interpreter.html">ToolDef interpreter</a></p></li>
       <li>
        <p><a href="release-notes.html">ToolDef release notes</a></p></li>
       <li>
        <p><a href="documentation-legal.html">Legal information</a></p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>Some screenshots of ToolDef editing and execution:</p>
     </div>
     <div class="imageblock">
      <div class="content">
       <img src="screenshot_ide.png" alt="screenshot ide">
      </div>
     </div>
     <div class="imageblock">
      <div class="content">
       <img src="screenshot_cmdline.png" alt="screenshot cmdline">
      </div>
     </div>
    </div>
   </div>
  </div>
  <script src="assets/highlight.min.js"></script>
  <script src="assets/languages/asciidoc.min.js"></script>
  <script src="assets/languages/bash.min.js"></script>
  <script src="assets/languages/bnf.min.js"></script>
  <script src="assets/languages/c.min.js"></script>
  <script src="assets/languages/chi.min.js"></script>
  <script src="assets/languages/cif.min.js"></script>
  <script src="assets/languages/console.min.js"></script>
  <script src="assets/languages/css.min.js"></script>
  <script src="assets/languages/dsm.min.js"></script>
  <script src="assets/languages/java.min.js"></script>
  <script src="assets/languages/javascript.min.js"></script>
  <script src="assets/languages/markdown.min.js"></script>
  <script src="assets/languages/mcrl2.min.js"></script>
  <script src="assets/languages/none.min.js"></script>
  <script src="assets/languages/plcst.min.js"></script>
  <script src="assets/languages/properties.min.js"></script>
  <script src="assets/languages/raildiagram.min.js"></script>
  <script src="assets/languages/setext.min.js"></script>
  <script src="assets/languages/shell.min.js"></script>
  <script src="assets/languages/tooldef.min.js"></script>
  <script src="assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>